package com.qs.mp.web.controller.api.admin;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.qs.mp.admin.domain.Supplier;
import com.qs.mp.admin.domain.param.SupplierCreateParam;
import com.qs.mp.admin.domain.param.SupplierParam;
import com.qs.mp.admin.service.ISupplierService;
import com.qs.mp.common.core.domain.AjaxResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Objects;

/**
 * 供应商管理API
 * @author Cup
 * @date 2022/5/10
 */
@Api(tags = "供应商管理API")
@RestController
@RequestMapping("/api/v1/mp/admin/supplier/*")
public class SupplierMgrController {

    @Autowired
    private ISupplierService supplierService;


    @PostMapping("/create")
    @ApiOperation("添加供应商")
    public AjaxResult createSupplier(@RequestBody @Validated SupplierCreateParam supplierParam) {
        int count = supplierService.count(new LambdaQueryWrapper<Supplier>().eq(Supplier::getName, supplierParam.getName()));
        if (count != 0) {
            return AjaxResult.error("供应商名称已存在");
        }
        Supplier supplier = new Supplier();
        BeanUtils.copyProperties(supplierParam, supplier);
        return AjaxResult.success(supplierService.save(supplier));
    }

}
